mod Ex06b

incl Mtex

incl Mtexrc

incl Maux

incl Mauxb

loc rem 
  \para \bf  6. CVICENIE Z PREDMETU 1-INF-450 LOGIKA PRE INFORMATIKOV  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.16 
  \para* \it  Datum:  \end stvrtok 26.10.2006 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-INF-450-lpi/0607zs/?lang=sk 
  \para* \it  Kontakt:  \end mailto:komara@nw.fmph.uniba.sk 

loc rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane 'nested simple 
  recursion'. Zadanie sa sklada z tychto suborov: 
  \items 
   \item \para Subor(y) \it  mtex*.cl  \end obsahuje makra pre CL-TeX. 
   \item \para Subor(y) \it  maux*.cl  \end obsahuje definicie niektorych 
         funkcii a predikatov. 
   \item \para Subor(y) \it  ex*.cl  \end obsahuje ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

loc rem 
  \para \bf  Hodnotenie.  \end 
  \items 
   \item \para Pocet bodov za ulohy v tomto subore: 0 
   \item \para Pocet bodov za premiove ulohy v tomto subore: 3 
  \end
  \para Prenos: 
  \verbatim 
  ftp://barbie.nw.fmph.uniba.sk/data/vyuka/inf/cl/1-INF-450-lpi/prenos/ex/ex<ord>/<user>/ex*.cl 
  \end
  \para Odovzdat do 7.11.2006 (utorok) do 18:00. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Lecture Notes in Theory 
         of Computability. 2001. 
   \item \para \it  [2]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  [CL] Syntax.  \end See the module \it  Mclsyntax  \end in the file 
  \it  mclsyntax.cl  \end. 

rem 
  \para \bf  Chapter. Primitive Recursive Functions.  \end 

rem 
  \para \bf  Section. Nested Simple Recursion.  \end 

rem 
  \para \bf  Part. Dyadic Arithmetic.  \end See the module \it  Mauxb  \end in 
  the file \it  mauxb.cl  \end. 

rem 
  \para \bf  Part. Binary Trees.  \end See the module \it  Mauxb  \end in the 
  file \it  mauxb.cl  \end. 

rem 
  \para \bf  Part. Postorder Traversal.  \end See the module \it  Mauxb  \end in 
  the file \it  mauxb.cl  \end. 

rem 
  \para \bf  Part. Nested Simple Recursion.  \end 

theory Nested_simple_recursion

fun G 'Tex_f1_g'

fun/4 H1 'Tex_f4_h'

fun/2 Sb1 'Tex_f2_rec_nsr_sb1'

fun/3 Sb2 'Tex_f3_rec_nsr_sb2'

rem 
  \para \bf  Remark.  \end We assume that \ft G(y) \end, \ft H1(x,z1,z2,y) \end, 
  \ft Sb1(x,y) \end and \ft Sb2(x,y,z1) \end are all primitive recursive. Our 
  goal is to show that the following function is primitive recursive. 

fun/2 F 'Tex_f2_f'
  F(0,y) = G(y)
  F(x+1,y) = H1(x,F(x,Sb1(x,y)),F(x,Sb2(x,y,F(x,Sb1(x,y)))),y)

rem 
  \para \header* fun/2 Cvf 'Tex_f2_rec_nsr_cvf' \end We will derive 
  \ft F(x,y) \end as a p.r. function with the help of its course of values 
  function \ft Cvf(x,y) \end: 

fun/2 Cvf 'Tex_f2_rec_nsr_cvf'
  Cvf(0,y) = F(0,y),0,0
  Cvf(x+1,y) = F(x+1,y),Cvf(x,Sb1(x,y)),Cvf(x,Sb2(x,y,Proj1 Cvf(x,Sb1(x,y))))

rem 
  \para \bf  Exercise.  \end \header* fun/2 X 'Tex_f2_rec_nsr_x' \end Show that 
  there is a p.r. function \ft X(i,x) \end such that 
  \eq* 
    X(0,x) = x
  \end
  \eq* 
    X(S1(i),x) = X(i,x)-1
  \end
  \eq* 
    X(S2(i),x) = X(i,x)-1
  \end

fun/2 X 'Tex_f2_rec_nsr_x'
  X(i,x) = Foo

rem 
  \para \bf  Exercise.  \end \header* fun/2 Z 'Tex_f2_rec_nsr_z' \end Show that 
  there is a p.r. function \ft Z(i,t) \end such that 
  \eq* 
    Z(0,x,l,r) = x
  \end
  \eq* 
    Z(Dconc(1,i),x,l,r) = Z(i,l)
  \end
  \eq* 
    Z(Dconc(2,i),x,l,r) = Z(i,r)
  \end

fun/2 Z 'Tex_f2_rec_nsr_z'
  Z(i,t) = Foo

rem 
  \para \bf  Exercise.  \end \header* fun/4 Y 'Tex_f4_rec_nsr_y' \end Show that 
  there is a p.r. function \ft Y(i,x,y,t) \end such that 
  \eq* 
    Y(0,x,y,t) = y
  \end
  \eq* 
    Y(S1(i),x,y,t) = Sb1(X(S1(i),x),Y(i,x,y,t))
  \end
  \eq* 
    Y(S2(i),x,y,t) = Sb2(X(S2(i),x),Y(i,x,y,t),Z(S1(i),t))
  \end

fun/4 Y 'Tex_f4_rec_nsr_y'
  Y(i,x,y,t) = Foo

rem 
  \para \bf  Exercise.  \end \header* fun/2 P2d  \end Show that there is a p.r. 
  function \ft P2d(n,j) \end such that 
  \eq* 
    Fbt(t) & j < Sz(t) -> Dsz P2d(Dp(t),j) < Dp(t)
  \end
  \eq* 
    Fbt(t) & j < Sz(t) -> Plookup(t,j) = Z(P2d(Dp(t),j),t)
  \end
  \para \it  Hint.  \end Note that the function satisfies: 
  \eq* 
    j+1 < Exp(2,n) -> P2d(n+1,j) = Dconc(1,P2d(n,j))
  \end
  \eq* 
    j+1 < Exp(2,n) -> P2d(n+1,Exp(2,n)-1+j) = Dconc(2,P2d(n,j))
  \end
  \eq* 
    P2d(n+1,Exp(2,n+1)-2) = 0
  \end

fun/2 P2d 
  P2d(n,j) = Foo

rem 
  \para \bf  Exercise.  \end \header* fun/4 Node  \end 
  \header* fun/2 Cvf 'Tex_f2_rec_nsr_cvf' \end Define a p.r. function 
  \ft Node(i,x,y,t) \end satisfying 
  \eq* 
    Dsz(i) = x -> Node(i,x,y,t) = G Y(i,x,y,t)
  \end
  \eq* 
    Dsz(i) < x -> Node(i,x,y,t) = H1(X(i,x)-1,Z(S1(i),t),Z(S2(i),t),Y(i,x,y,t))
  \end
  \para We would like to have eventually that 
  \eq* 
    Dsz(i) <= x -> Node(i,x,y,Cvf(x,y)) = F(X(i,x),Y(i,x,y,Cvf(x,y)))
  \end

fun/4 Node 
  Node(i,x,y,t) = Foo

rem 
  \para \bf  Exercise.  \end \header* fun/4 Map  \end \header* fun/4 Map1  \end 
  Show that there is a p.r. function \ft Map(j,x,y,t) \end such that 
  \eq* 
    j >= Exp(2,x+1)-1 -> Map(j,x,y,t) = t
  \end
  \eq* 
    j < Exp(2,x+1)-1 -> 
    Map(j,x,y,t) = Map(j+1,x,y,Pupdate(t,j,Node(P2d(x+1,j),x,y,t)))
  \end
  \para \it  Hint.  \end Find a p.r. function \ft Map1(j1,x,y,t) \end such that 
  \eq* 
    j1+j = Exp(2,x+1)-1 -> Map1(j1,x,y,t) = Map(j,x,y,t)
  \end

fun/4 Map1 
  Map1(j1,x,y,t) = Foo

fun/4 Map 
  Map(j,x,y,t) = Foo

rem 
  \para \bf  Exercise.  \end \header* fun/2 Cvf 'Tex_f2_rec_nsr_cvf' \end Show 
  that the course of values function \ft Cvf(x,y) \end is primitive recursive. 

fun/2 Cvf_is_primrec 'Tex_f2_rec_nsr_cvf'
  Cvf_is_primrec(x,y) = Foo

rem 
  \para \bf  Exercise.  \end \it  [Premiova uloha (3 body)]  \end Show that the 
  function \ft F(x,y) \end is primitive recursive. 

fun/2 F_is_primrec 'Tex_f2_f'
  F_is_primrec(x,y) = Foo

end theory Nested_simple_recursion

loc rem 
  ******************************************************************************
  ********************************* DEBUGGING **********************************
  ******************************************************************************

loc fun Test_fun 
  Test_fun(x) = Foo

loc fun/2 Itfa 
  Itfa(0,a) = a
  Itfa(n+1,a) = Itfa(n,(n,Test_fun(n)),a)

loc fun Itf 
  Itf(n) = Itfa(n,0)

loc pred Test_pred 
  Test_pred(x) <-> Poo

loc fun/2 Itpa 
  Itpa(0,a) = a
  Itpa(n+1,a) = Itpa(n,n,a) <- Test_pred(n)
  Itpa(n+1,a) = Itpa(n,a) <- ~Test_pred(n)

loc fun Itp 
  Itp(n) = Itpa(n,0)

loc rem 
  \para Formats for testing binary functions and predicates. Examples of usage: 
  \items 
   \item \para define \ft Test_fun(x) = H(x)+T(x) \end and run query \it  
         Itf(10)=x:Lf2  \end 
   \item \para define \ft Test_pred(x) <-> H(x) <= T(x) \end and run query \it  
         Itp(10)=x:Lp2  \end 
  \end

loc pred Nn 
  Nn(0)
  Nn(x1,x2) <- N(x1) & N(x2)

loc pred Nnn 
  Nnn(x,y) <- Nn(x) & N(y)

loc pred Lf2 
  Lf2(0)
  Lf2(v,w) <- Nnn(v) & Lf2(w)

loc pred Lp2 
  Lp2(0)
  Lp2(v,w) <- Nn(v) & Lp2(w)

loc rem 
  \para And finally, a very useful query: 
  \verbatim 
  0,0 = x,y & Cvf_is_primrec(x,y) = t1 & Cvf(x,y) = t2 & t1 = t2 
  \end

