mod Ex06a

incl Mtex

incl Mtexrc

incl Maux

rem 
  \para \bf  6. CVICENIE Z PREDMETU 1-INF-450 LOGIKA PRE INFORMATIKOV  \end 

rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.16 
  \para* \it  Datum:  \end stvrtok 26.10.2006 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-INF-450-lpi/0607zs/?lang=sk 
  \para* \it  Kontakt:  \end mailto:komara@nw.fmph.uniba.sk 

rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane 'nested simple 
  recursion'. Zadanie sa sklada z tychto suborov: 
  \items 
   \item \para Subor(y) \it  mtex*.cl  \end obsahuje makra pre CL-TeX. 
   \item \para Subor(y) \it  maux*.cl  \end obsahuje definicie niektorych 
         funkcii a predikatov. 
   \item \para Subor(y) \it  ex*.cl  \end obsahuje ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

rem 
  \para \bf  Hodnotenie.  \end 
  \items 
   \item \para Pocet bodov za ulohy v tomto subore: 3 
   \item \para Pocet bodov za premiove ulohy v tomto subore: 0 
  \end
  \para Prenos: 
  \verbatim 
  ftp://barbie.nw.fmph.uniba.sk/data/vyuka/inf/cl/1-INF-450-lpi/prenos/ex/ex<ord>/<user>/ex*.cl 
  \end
  \para Odovzdat do 7.11.2006 (utorok) do 18:00. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Lecture Notes in Theory 
         of Computability. 2001. 
   \item \para \it  [2]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  [CL] Syntax.  \end See the module \it  Mclsyntax  \end in the file 
  \it  mclsyntax.cl  \end. 

rem 
  \para \bf  [CL] Remark.  \end \header* fun/3 H1 'Tex_f3_h' \end 
  \header* fun F1 'Tex_f1_f1' \end \header* fun/2 G 'Tex_f2_g' \end Assignments 
  (even nested) are allowed in the definitions of p.r. functions. Example: 
  \def 
    fun F 'Tex_f1_f'
    F(x) = H1(x,y,z) <- F1(x) = y & G(x,y) = z
  \end
  \para The convention holds only in this module! 

rem 
  \para \bf  Chapter. Primitive Recursive Functions.  \end 

rem 
  \para \bf  Section. Nested Simple Recursion.  \end 

rem 
  \para \bf  Part. Dyadic Arithmetic.  \end 

rem 
  \para \bf  Exercise.  \end \header* fun Dsz 'Tex_f1_n2_sz' \end Define dyadic 
  size \ft Dsz(x) \end as a p.r. function. The function satisfies 
  \eq* 
    Dsz(0) = 0
  \end
  \eq* 
    Dsz S1(x) = Dsz(x)+1
  \end
  \eq* 
    Dsz S2(x) = Dsz(x)+1
  \end

fun Dsz 'Tex_f1_n2_sz'
  Dsz(x) = Foo

rem 
  \para \bf  Exercise.  \end \header* fun/2 Dconc 'Tex_f2_n2_conc' \end Define 
  dyadic concatenation \ft Dconc(x,y) \end as a p.r. function. The function 
  satisfies 
  \eq* 
    Dconc(x,0) = x
  \end
  \eq* 
    Dconc(x,S1(y)) = S1 Dconc(x,y)
  \end
  \eq* 
    Dconc(x,S2(y)) = S2 Dconc(x,y)
  \end

fun/2 Dconc 'Tex_f2_n2_conc'
  Dconc(x,y) = Foo

rem 
  \para \bf  Exercise.  \end \it  [Uloha (1 bod)]  \end 
  \header* fun Drev 'Tex_f1_n2_rev' \end Define dyadic reversal \ft Drev(x) \end 
  as a p.r. function. The function satisfies 
  \eq* 
    Drev(0) = 0
  \end
  \eq* 
    Drev S1(x) = Dconc(1,Drev(x))
  \end
  \eq* 
    Drev S2(x) = Dconc(2,Drev(x))
  \end

fun Drev 'Tex_f1_n2_rev'
  Drev(x) = Foo

rem 
  \para \bf  Part. Binary Trees.  \end 

rem 
  \para \bf  Binary trees.  \end \it  [Uloha (1 bod)]  \end 
  \header* fun Btf 'Tex_f1_rec_nsr_bt_char_bt' \end Show that there is a p.r. 
  predicate \ft Bt(t) \end such that 
  \eq* 
    Bt(t) <-> t = 0 \/ \e x\e l\e r(t = x,l,r & Bt(l) & Bt(r))
  \end
  \para \it  Hint.  \end Define the predicate with the help of its 
  characteristic function. 

fun Btf 'Tex_f1_rec_nsr_bt_char_bt'
  Btf(t) = Foo

pred Bt 
  Bt(t) <-> Poo

rem 
  \para \bf  Exercise.  \end \header* fun Sz 'Tex_f1_rec_nsr_bt_sz' \end Show 
  that the function \ft Sz(t) \end, which yields the size of the binary tree 
  \ft t \end, is a p.r. function. The function satisfies 
  \eq* 
    Sz(0) = 0
  \end
  \eq* 
    Sz(x,l,r) = Sz(l)+Sz(r)+1
  \end

fun Sz 'Tex_f1_rec_nsr_bt_sz'
  Sz(t) = Foo

rem 
  \para \bf  Exercise.  \end \header* fun Dp 'Tex_f1_rec_nsr_bt_dp' \end Show 
  that the function \ft Dp(t) \end, which yields the depth of the binary tree 
  \ft t \end, as a p.r. function. The function satisfies 
  \eq* 
    Dp(0) = 0
  \end
  \eq* 
    Dp(x,l,r) = Max(Dp(l),Dp(r))+1
  \end

fun Dp 'Tex_f1_rec_nsr_bt_dp'
  Dp(t) = Foo

rem 
  \para \bf  Exercise.  \end 
  \header* fun/2 Dlookup 'Tex_f2_rec_nsr_bt_dyadic_lookup' \end Show that the 
  binary function \ft Dlookup(t,i) \end satisfying 
  \eq* 
    Dlookup((x,l,r),0) = x
  \end
  \eq* 
    Dlookup((x,l,r),S1(i)) = Dlookup(l,i)
  \end
  \eq* 
    Dlookup((x,l,r),S2(i)) = Dlookup(r,i)
  \end
  \para is primitive recursive. 
  \para \it  Hint.  \end Define the function with the help of its contraction. 

fun Cntr_dlookup 'Tex_f1_pp_cntr'
  Cntr_dlookup(0) = 0
  Cntr_dlookup(x1+1) = Foo

fun/2 Dlookup 'Tex_f2_rec_nsr_bt_dyadic_lookup'
  Dlookup(t,i) = Foo

rem 
  \para \bf  Full binary trees.  \end Define the predicate \ft Fbt(t) \end 
  holding of full binary trees as primitive recursive. 

pred Fbt 
  Fbt(t) <-> Poo

rem 
  \para \bf  New full binary tree.  \end Show that there is a p.r. function 
  \ft New(n) \end such that 
  \eq* 
    Fbt New(n) & Dp New(n) = n
  \end

fun New 
  New(n) = Foo

rem 
  \para \bf  Part. Postorder Traversal.  \end 

rem 
  \para \bf  Exercise.  \end \it  [Uloha (1 bod)]  \end 
  \header* fun/2 Plookup 'Tex_f2_rec_nsr_bt_postorder_lookup' \end Define the 
  tree indexing function \ft Plookup(t,j) \end as a p.r. function. The indexing 
  schema corresponds to postorder traversal of binary trees. 
  \para \it  Hint.  \end Define the function with the help of its contraction. 

fun Cntr_plookup 'Tex_f1_pp_cntr'
  Cntr_plookup(0) = 0
  Cntr_plookup(x1+1) = Foo

fun/2 Plookup 'Tex_f2_rec_nsr_bt_postorder_lookup'
  Plookup(t,i) = Foo

rem 
  \para \bf  Exercise.  \end 
  \header* fun/3 Pupdate 'Tex_f3_rec_nsr_bt_postorder_update' \end Show that the 
  function \ft Pupdate(t,j,x) \end satisfying 
  \eq* 
    Bt(t) & j < Sz(t) -> Bt Pupdate(t,i,x)
  \end
  \eq* 
    Bt(t) & i < Sz(t) -> Sz Pupdate(t,i,x) = Sz(t) & Dp Pupdate(t,i,x) = Dp(t)
  \end
  \eq* 
    Bt(t) & i < Sz(t) -> Plookup(Pupdate(t,i,x),i) = x
  \end
  \eq* 
    Bt(t) & i < Sz(t) & j < Sz(t) & j != i -> 
    Plookup(Pupdate(t,i,x),j) = Plookup(t,j)
  \end
  \para is primitive recursive. 
  \para \it  Hint.  \end Define the function with the help of its contraction. 

fun Cntr_pupdate 'Tex_f1_pp_cntr'
  Cntr_pupdate(0) = 0
  Cntr_pupdate(x1+1) = Foo

fun/3 Pupdate 'Tex_f3_rec_nsr_bt_postorder_update'
  Pupdate(t,i,x) = Foo

loc rem 
  ******************************************************************************
  ********************************* DEBUGGING **********************************
  ******************************************************************************

loc fun Test_fun 
  Test_fun(x) = Foo

loc fun/2 Itfa 
  Itfa(0,a) = a
  Itfa(n+1,a) = Itfa(n,(n,Test_fun(n)),a)

loc fun Itf 
  Itf(n) = Itfa(n,0)

loc pred Test_pred 
  Test_pred(x) <-> Poo

loc fun/2 Itpa 
  Itpa(0,a) = a
  Itpa(n+1,a) = Itpa(n,n,a) <- Test_pred(n)
  Itpa(n+1,a) = Itpa(n,a) <- ~Test_pred(n)

loc fun Itp 
  Itp(n) = Itpa(n,0)

rem 
  \para Formats for testing binary functions and predicates. Examples of usage: 
  \items 
   \item \para define \ft Test_fun(x) = H(x)+T(x) \end and run query \it  
         Itf(10)=x:Lf2  \end 
   \item \para define \ft Test_pred(x) <-> H(x) <= T(x) \end and run query \it  
         Itp(10)=x:Lp2  \end 
  \end

loc pred Nn 
  Nn(0)
  Nn(x1,x2) <- N(x1) & N(x2)

loc pred Nnn 
  Nnn(x,y) <- Nn(x) & N(y)

loc pred Lf2 
  Lf2(0)
  Lf2(v,w) <- Nnn(v) & Lf2(w)

loc pred Lp2 
  Lp2(0)
  Lp2(v,w) <- Nn(v) & Lp2(w)

